# Class LinkException

java.lang.Object
java.lang.Throwable
java.lang.Exception
javax.naming.NamingException
javax.naming.LinkException

All Implemented Interfaces:
  `Serializable`

Direct Known Subclasses:
  `LinkLoopException, MalformedLinkException`

public class LinkException extends NamingException
This exception is used to describe problems encountered while resolving links. Additional information is added to the base NamingException for pinpointing the problem with the link.

Analogously to how NamingException captures name resolution information, LinkException captures "link"-name resolution information pinpointing the problem encountered while resolving a link. All these fields may be null.

- Link Resolved Name. Portion of link name that has been resolved.
- Link Resolved Object. Object to which resolution of link name proceeded.
- Link Remaining Name. Portion of link name that has not been resolved.
- Link Explanation. Detail explaining why link resolution failed.

A LinkException instance is not synchronized against concurrent multithreaded access. Multiple threads trying to access and modify a single LinkException instance should lock the object.

Since:
  1.3
See Also:
  - `Context.lookupLink(Name)`
  - `LinkRef`
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected String`
  `linkExplanation`
  Contains the exception of why resolution of the link failed.
  `protected Name`
  `linkRemainingName`
  Contains the remaining link name that has not been resolved yet.
  `protected Name`
  `linkResolvedName`
  Contains the part of the link that has been successfully resolved.
  `protected Object`
  `linkResolvedObj`
  Contains the object to which resolution of the part of the link was successful.

  ### Fields declared in class NamingException

  `remainingName, resolvedName, resolvedObj, rootException`
  Modifier and Type
  Field
  Description
  `protected Name`
  `remainingName`
  Contains the remaining name that has not been resolved yet.
  `protected Name`
  `resolvedName`
  Contains the part of the name that has been successfully resolved.
  `protected Object`
  `resolvedObj`
  Contains the object to which resolution of the part of the name was successful.
  `protected Throwable`
  `rootException`
  Contains the original exception that caused this NamingException to be thrown.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LinkException()`
  Constructs a new instance of LinkException.
  `LinkException(String explanation)`
  Constructs a new instance of LinkException with an explanation.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getLinkExplanation()`
  Retrieves the explanation associated with the problem encountered when resolving a link.
  `Name`
  `getLinkRemainingName()`
  Retrieves the remaining unresolved portion of the link name.
  `Name`
  `getLinkResolvedName()`
  Retrieves the leading portion of the link name that was resolved successfully.
  `Object`
  `getLinkResolvedObj()`
  Retrieves the object to which resolution was successful.
  `void`
  `setLinkExplanation(String msg)`
  Sets the explanation associated with the problem encountered when resolving a link.
  `void`
  `setLinkRemainingName(Name name)`
  Sets the remaining link name field of this exception.
  `void`
  `setLinkResolvedName(Name name)`
  Sets the resolved link name field of this exception.
  `void`
  `setLinkResolvedObj(Object obj)`
  Sets the link resolved object field of this exception.
  `String`
  `toString()`
  Generates the string representation of this exception.
  `String`
  `toString(boolean detail)`
  Generates the string representation of this exception.

  ### Methods declared in class NamingException

  `appendRemainingComponent, appendRemainingName, getCause, getExplanation, getRemainingName, getResolvedName, getResolvedObj, getRootCause, initCause, setRemainingName, setResolvedName, setResolvedObj, setRootCause`
  Modifier and Type
  Method
  Description
  `void`
  `appendRemainingComponent(String name)`
  Add name as the last component in remaining name.
  `void`
  `appendRemainingName(Name name)`
  Add components from 'name' as the last components in remaining name.
  `Throwable`
  `getCause()`
  Returns the cause of this exception.
  `String`
  `getExplanation()`
  Retrieves the explanation associated with this exception.
  `Name`
  `getRemainingName()`
  Retrieves the remaining unresolved portion of the name.
  `Name`
  `getResolvedName()`
  Retrieves the leading portion of the name that was resolved successfully.
  `Object`
  `getResolvedObj()`
  Retrieves the object to which resolution was successful.
  `Throwable`
  `getRootCause()`
  Retrieves the root cause of this NamingException, if any.
  `Throwable`
  `initCause(Throwable cause)`
  Initializes the cause of this exception to the specified value.
  `void`
  `setRemainingName(Name name)`
  Sets the remaining name field of this exception.
  `void`
  `setResolvedName(Name name)`
  Sets the resolved name field of this exception.
  `void`
  `setResolvedObj(Object obj)`
  Sets the resolved object field of this exception.
  `void`
  `setRootCause(Throwable e)`
  Records the root cause of this NamingException.

  ### Methods declared in class Throwable

  `addSuppressed, fillInStackTrace, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, printStackTrace, printStackTrace, printStackTrace, setStackTrace`
  Modifier and Type
  Method
  Description
  `final void`
  `addSuppressed(Throwable exception)`
  Appends the specified exception to the exceptions that were suppressed in order to deliver this exception.
  `Throwable`
  `fillInStackTrace()`
  Fills in the execution stack trace.
  `String`
  `getLocalizedMessage()`
  Creates a localized description of this throwable.
  `String`
  `getMessage()`
  Returns the detail message string of this throwable.
  `StackTraceElement[]`
  `getStackTrace()`
  Provides programmatic access to the stack trace information printed by `Throwable.printStackTrace()`.
  `final Throwable[]`
  `getSuppressed()`
  Returns an array containing all of the exceptions that were suppressed, typically by the `try`-with-resources statement, in order to deliver this exception.
  `void`
  `printStackTrace()`
  Prints this throwable and its backtrace to the standard error stream.
  `void`
  `printStackTrace(PrintStream s)`
  Prints this throwable and its backtrace to the specified print stream.
  `void`
  `printStackTrace(PrintWriter s)`
  Prints this throwable and its backtrace to the specified print writer.
  `void`
  `setStackTrace(StackTraceElement[] stackTrace)`
  Sets the stack trace elements that will be returned by `Throwable.getStackTrace()` and printed by `Throwable.printStackTrace()` and related methods.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### linkResolvedName

    protected Name linkResolvedName
    Contains the part of the link that has been successfully resolved. It is a composite name and can be null. This field is initialized by the constructors. You should access and manipulate this field through its get and set methods.
    See Also:
      - `getLinkResolvedName()`
      - `setLinkResolvedName(Name)`

  - ### linkResolvedObj

    protected Object linkResolvedObj
    Contains the object to which resolution of the part of the link was successful. Can be null. This field is initialized by the constructors. You should access and manipulate this field through its get and set methods.
    See Also:
      - `getLinkResolvedObj()`
      - `setLinkResolvedObj(Object)`

  - ### linkRemainingName

    protected Name linkRemainingName
    Contains the remaining link name that has not been resolved yet. It is a composite name and can be null. This field is initialized by the constructors. You should access and manipulate this field through its get and set methods.
    See Also:
      - `getLinkRemainingName()`
      - `setLinkRemainingName(Name)`

  - ### linkExplanation

    protected String linkExplanation
    Contains the exception of why resolution of the link failed. Can be null. This field is initialized by the constructors. You should access and manipulate this field through its get and set methods.
    See Also:
      - `getLinkExplanation()`
      - `setLinkExplanation(String)`

- ## Constructor Details

  - ### LinkException

    public LinkException(String explanation)
    Constructs a new instance of LinkException with an explanation. All the other fields are initialized to null.
    Parameters:
      `explanation` - A possibly null string containing additional detail about this exception.
    See Also:
      - `Throwable.getMessage()`

  - ### LinkException

    public LinkException()
    Constructs a new instance of LinkException. All the non-link-related and link-related fields are initialized to null.

- ## Method Details

  - ### getLinkResolvedName

    public Name getLinkResolvedName()
    Retrieves the leading portion of the link name that was resolved successfully.
    Returns:
      The part of the link name that was resolved successfully. It is a composite name. It can be null, which means the link resolved name field has not been set.
    See Also:
      - `getLinkResolvedObj()`
      - `setLinkResolvedName(Name)`

  - ### getLinkRemainingName

    public Name getLinkRemainingName()
    Retrieves the remaining unresolved portion of the link name.
    Returns:
      The part of the link name that has not been resolved. It is a composite name. It can be null, which means the link remaining name field has not been set.
    See Also:
      - `setLinkRemainingName(Name)`

  - ### getLinkResolvedObj

    public Object getLinkResolvedObj()
    Retrieves the object to which resolution was successful. This is the object to which the resolved link name is bound.
    Returns:
      The possibly null object that was resolved so far. If null, it means the link resolved object field has not been set.
    See Also:
      - `getLinkResolvedName()`
      - `setLinkResolvedObj(Object)`

  - ### getLinkExplanation

    public String getLinkExplanation()
    Retrieves the explanation associated with the problem encountered when resolving a link.
    Returns:
      The possibly null detail string explaining more about the problem with resolving a link. If null, it means there is no link detail message for this exception.
    See Also:
      - `setLinkExplanation(String)`

  - ### setLinkExplanation

    public void setLinkExplanation(String msg)
    Sets the explanation associated with the problem encountered when resolving a link.
    Parameters:
      `msg` - The possibly null detail string explaining more about the problem with resolving a link. If null, it means no detail will be recorded.
    See Also:
      - `getLinkExplanation()`

  - ### setLinkResolvedName

    public void setLinkResolvedName(Name name)
    Sets the resolved link name field of this exception.

    `name` is a composite name. If the intent is to set this field using a compound name or string, you must "stringify" the compound name, and create a composite name with a single component using the string. You can then invoke this method using the resulting composite name.

    A copy of `name` is made and stored. Subsequent changes to `name` do not affect the copy in this NamingException and vice versa.

    Parameters:
      `name` - The name to set resolved link name to. This can be null. If null, it sets the link resolved name field to null.
    See Also:
      - `getLinkResolvedName()`

  - ### setLinkRemainingName

    public void setLinkRemainingName(Name name)
    Sets the remaining link name field of this exception.

    `name` is a composite name. If the intent is to set this field using a compound name or string, you must "stringify" the compound name, and create a composite name with a single component using the string. You can then invoke this method using the resulting composite name.

    A copy of `name` is made and stored. Subsequent changes to `name` do not affect the copy in this NamingException and vice versa.

    Parameters:
      `name` - The name to set remaining link name to. This can be null. If null, it sets the remaining name field to null.
    See Also:
      - `getLinkRemainingName()`

  - ### setLinkResolvedObj

    public void setLinkResolvedObj(Object obj)
    Sets the link resolved object field of this exception. This indicates the last successfully resolved object of link name.
    Parameters:
      `obj` - The object to set link resolved object to. This can be null. If null, the link resolved object field is set to null.
    See Also:
      - `getLinkResolvedObj()`

  - ### toString

    public String toString()
    Generates the string representation of this exception. This string consists of the NamingException information plus the link's remaining name. This string is used for debugging and not meant to be interpreted programmatically.
    Overrides:
      `toString` in class `NamingException`
    Returns:
      The non-null string representation of this link exception.

  - ### toString

    public String toString(boolean detail)
    Generates the string representation of this exception. This string consists of the NamingException information plus the additional information of resolving the link. If 'detail' is true, the string also contains information on the link resolved object. If false, this method is the same as the form of toString() that accepts no parameters. This string is used for debugging and not meant to be interpreted programmatically.
    Overrides:
      `toString` in class `NamingException`
    Parameters:
      `detail` - If true, add information about the link resolved object.
    Returns:
      The non-null string representation of this link exception.